<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Bestellingen extends Controller_DefaultTemplate {

	public function action_index()
	{
		$this->redirect('bestellingen/bevestig');
	}

	/* VIEWS */
	public function action_bevestig()
	{
		$this->template->nav = View::factory('nav/bestellingen');
		$this->template->content = View::factory('algemeen/bestellingen_bevestig');
	}

	public function action_all()
	{
		$datum=date('Y-m-d');
		if(isset($_GET['datum'])){
			$datum=$_GET['datum'];
		}
		$content['datum']=$datum;
		$this->template->nav = View::factory('nav/bestellingen');
		$this->template->content = View::factory('algemeen/bestellingen_all',$content);
	}

	public function action_manquant()
	{
		$mdl= new Model_Orders();
		$datum=date('Y-m-d');
		if(isset($_GET['datum'])){
			$datum=$_GET['datum'];
		}
		$bestellingen= $mdl->getManquant($datum);
		$content['datum']=$datum;
	    $content['bestellingen'] = $bestellingen;
		$this->template->nav = View::factory('nav/bestellingen');
		$this->template->content = View::factory('algemeen/bestellingen_manquant',$content);
	}

	public function action_origine()
	{
		$mdl= new Model_Artikels();
		$datum=date('Y-m-d');
		if(isset($_GET['datum'])){
			$datum=$_GET['datum'];
		}
		$artikels= $mdl->getArtikelOrigine($datum);
		$content['datum']=$datum;
	    $content['artikels'] = $artikels;
		$this->template->nav = View::factory('nav/bestellingen');
		$this->template->content = View::factory('algemeen/bestellingen_origine',$content);
	}



	/* DATA TABLE */
	public function action_tblBestelHistoriek()
	{

		$mdl= new Model_Orders();
	    $output = $mdl->getDataBestellingen();
		echo json_encode($output);
	}

	/* DATA TABLE - Detail - BLOCKS*/
	public function action_vwBestellingDetail()
	{
		$mdl= new Model_Orders();
		$bestellingen= $mdl->getBestelling($_POST['bestelid']);
	    $content['bestelling'] = $bestellingen[0];
		$mdl= new Model_Leveringen();
		$content['leveringen'] = $mdl->getLevering($_POST['bestelid']);
		echo View::factory('algemeen/bl_bestelling_detail',$content);
	}

	public function action_vwBestellingBevestigen()
	{
		$mdl= new Model_Orders();
		$bestellingen= $mdl->getBestelling($_POST['bestelid']);
	    $content['bestelling'] = $bestellingen[0];
		echo View::factory('algemeen/bl_bestelling_bevestig',$content);
	}

	/* PDF's */
	public function action_pdfBestelling()
	{
		try{
			$this->profiler = NULL;
			$this->auto_render = FALSE;
			$this->response->headers('Content-Type','application/pdf');

			$mdl= new Model_Orders();
			$bestellingen=$mdl->getBestelling($_GET['bestelid']);
			$bestelling= $bestellingen[0];
			include('assets/pdf/bestel_pdf.php');
			// FPDF object
			$bpdf = new BestelPDF();
			$bpdf->SetAutoPageBreak(true, 10);
			$bpdf->setGegevens($bestelling);
			$bpdf->AliasNbPages();
			$bpdf->SetDisplayMode(100);
			$bpdf->SetFont('Helvetica','',10);
			$bpdf->AddPage();
			$bpdf->BestellingTabel($bestelling);
			$bpdf->Output('bestelling.pdf','I');
		}catch(Exception $error){
			Log::instance()->add(Log::ERROR, $error->getMessage());
			$this->redirect('bestellingen/all');
		}


	}

	public function action_pdfReceptie()
	{
		try{
			$this->profiler = NULL;
			$this->auto_render = FALSE;
			$this->response->headers('Content-Type','application/pdf');

			$mdl= new Model_Orders();
			$bestellingen=$mdl->getBestelling($_GET['bestelid']);
			$bestelling= $bestellingen[0];
			include('assets/pdf/bestel_pdf.php');
			// FPDF object
			$bpdf = new BestelPDF();
			$bpdf->SetAutoPageBreak(true, 10);
			$bpdf->setGegevens($bestelling);
			$bpdf->AliasNbPages();
			$bpdf->SetDisplayMode(100);
			$bpdf->SetFont('Helvetica','',10);
			$bpdf->AddPage();
			$bpdf->ReceptieTabel($bestelling);
			$bpdf->Output('receptie.pdf','I');
		}catch(Exception $error){
			Log::instance()->add(Log::ERROR, $error->getMessage());
			$this->redirect('bestellingen/all');
		}
	}

	public function action_pdfLevering()
	{
		try{
			$this->profiler = NULL;
			$this->auto_render = FALSE;
			$this->response->headers('Content-Type','application/pdf');

			$mdl= new Model_Leveringen();
			$leveringen = $mdl->getLevering($_GET['bestelid']);
			include('assets/pdf/desadv_pdf.php');
			// FPDF object
			$pdf = new DesadvPDF();
			$pdf->SetAutoPageBreak(true, 10);
			$pdf->SetDrawColor(180);
			$pdf->SetTextColor(50);
			$pdf->AliasNbPages();
			$pdf->SetDisplayMode(100);
			$pdf->SetFont('Helvetica','',10);
			foreach($leveringen as $levering){
				$pdf->setGegevens($levering);
				$pdf->AddPage();
				$pdf->LeveringTabel($levering);
			}
			$pdf->Output();
		}catch(Exception $error){
			Log::instance()->add(Log::ERROR, $error->getMessage());
			$this->redirect('bestellingen/all');
		}
	}

	public function action_pdfLeveringDatum()
	{
		try{
		$this->profiler = NULL;
		$this->auto_render = FALSE;
		$this->response->headers('Content-Type','application/pdf');

		$mdl= new Model_Leveringen();
		$leveringen = $mdl->getLeveringenDatum($_GET['leveringvan']);
		include('assets/pdf/desadv_pdf.php');
		// FPDF object
		$pdf = new DesadvPDF();
		$pdf->SetAutoPageBreak(true, 10);
		$pdf->SetDrawColor(180);
		$pdf->SetTextColor(50);
		$pdf->AliasNbPages();
		$pdf->SetDisplayMode(100);
		$pdf->SetFont('Helvetica','',10);
		foreach($leveringen as $levering){
			$pdf->setGegevens($levering);
			$pdf->AddPage();
			$pdf->LeveringTabel($levering);
		}
		$pdf->Output();
		}catch(Exception $error){
			Log::instance()->add(Log::ERROR, $error->getMessage());
			$this->redirect('bestellingen/all');
		}
	}

	/* PDF GROEP */
	public function action_pdfGroepBestelling()
	{
		try{
		$mdl= new Model_Orders();
		$bestellingen=$mdl->getOpenBestellingenGroep($_GET['leverdatum']);
		$this->profiler = NULL;
		$this->auto_render = FALSE;
		$this->response->headers('Content-Type','application/pdf');

		require('assets/pdf/bestel_pdf.php');
		// FPDF object
		$pdf = new BestelPDF();
		$pdf->SetAutoPageBreak(true, 10);
		$pdf->SetDrawColor(180);
		$pdf->SetTextColor(50);
		$pdf->setGegevens($bestellingen[0]);
		$pdf->AliasNbPages();
		$pdf->SetDisplayMode(100);
		$pdf->SetFont('Helvetica','',10);
		$pdf->AddPage();
		$pdf->GroepTabel($bestellingen);
		$pdf->Output();
		}catch(Exception $error){
			Log::instance()->add(Log::ERROR, $error->getMessage());
			$this->redirect('bestellingen/all');
		}
	}

	/* HERINNERINGS MAIL STUREN */
	public function action_mailHerinneringBestelling()
	{
		try{
			$mdl= new Model_Orders();
			$bestelling=$mdl->getBestelling($_POST['bestelid']);

			//mail sturen
			$tomail=Kohana::$config->load('appconf.tomail');

			$mdlLev= new Model_Leverancier();
			$contacten=$mdlLev->getContactenLeverancierMail($bestelling[0]['leverancierid'],1);
			$tomail.=",".$contacten['mail'];

			$mdl=new Model_Mail();
			$mdl->setSubject("[REMINDER ORDER: ".$bestelling[0]['bestelid']."] ".$bestelling[0]['leverancierid']. " ".$bestelling[0]['leverancier']. "");
			$mdl->setTo(array_unique(explode(",",rtrim($tomail,","))));
			$mdl->mailBestelling($bestelling[0],$bestelling[0]['nota']);


			$response['success']=true;
			$response['message']="Herinnerings mail is verstuurd naar leverancier.";
		}catch(Exception $e){
			$response['success']=false;
			$response['message']="Error:<br/>".$e->getMessage();
		}
		echo json_encode($response);
	}

	public function action_mailOpnieuwBestelling()
	{
		try{
			$mdl=new Model_Leveringen();
			$levering=$mdl->getLevering($_POST['bestelid']);

			//mail sturen
			$tomail=Kohana::$config->load('appconf.tomail');

			$mdlLev= new Model_Leverancier();
			$contacten=$mdlLev->getContactenLeverancierMail($levering['leverancierid'],1);
			$tomail.=",".$contacten['mail'];

			$mdl=new Model_Mail();
			$mdl->setSubject("[DESADV: ".$levering['leveringid']."] ".$levering['leverancierid']. " ".$levering['leverancier']);
			$mdl->setTo(array_unique(explode(",",rtrim($tomail,","))));
			$response=$mdl->mailDesadv($levering,"");

			$response['success']=true;
			$response['message']="Mail is verstuurd naar leverancier.";
		}catch(Exception $e){
			$response['success']=false;
			$response['message']="Error:<br/>".$e->getMessage();
		}
		echo json_encode($response);
	}

}
