<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Leverancier extends Controller_DefaultTemplate {

	public function action_index()
	{
		$this->redirect('Leverancier/bestel');
	}

	/* VIEWS */
	public function action_bestel()
	{
		$mdl= new Model_Login();
		$nav['slLev']=$mdl->getLeveranciers(1);
		$content['slAankoper']=$mdl->getAankopers();
		$mdl= new Model_LeverancierArtikels();
		$content['artikels']=$mdl->getBestelLijstLeverancier();
		$content['slZones']=$mdl->getZonesAankoper($_SESSION['VMI']['slAankoper']);
		$mdl= new Model_Leeggoed();
		$content['leeggoed']=$mdl->getLeeggoedLeverancier();
		$this->template->nav = View::factory('nav/leverancier',$nav);
		$this->template->content = View::factory('leverancier/bestel',$content);
	}

	public function action_bevestig()
	{
		$mdl= new Model_Login();
		$nav['slLev']=$mdl->getLeveranciers(1);
		$content['levid']="#µ=".$_SESSION['VMI']['slLev'];
		$this->template->nav = View::factory('nav/leverancier',$nav);
		$this->template->content = View::factory('algemeen/bestellingen_bevestig',$content);
	}

	public function action_all()
	{
		$datum=date('Y-m-d');
		if(isset($_GET['datum'])){
			$datum=$_GET['datum'];
		}
		$content['datum']=$datum;
		$mdl= new Model_Login();
		$nav['slLev']=$mdl->getLeveranciers(1);
		$content['levid']="#µ=".$_SESSION['VMI']['slLev'];
		$this->template->nav = View::factory('nav/leverancier',$nav);
		$this->template->content = View::factory('algemeen/bestellingen_all',$content);
	}

	public function action_artikels()
	{
		$mdl= new Model_Login();
		$nav['slLev']=$mdl->getLeveranciers(1);
		$mdl= new Model_LeverancierArtikels();
		if($_SESSION['VMI']['gebruiker']=="aankoper"){
			$content['artikels']=$mdl->getArtikelsLeverancier();
		}else {
			$content['artikels']=$mdl->getArtikelsLeverancier(1);
		}
		$this->template->nav = View::factory('nav/leverancier',$nav);
		$this->template->content = View::factory('leverancier/artikels',$content);
	}

	public function action_zoneartikels()
	{
		$mdl= new Model_Login();
		$nav['slLev']=$mdl->getLeveranciers(1);
		$mdl= new Model_LeverancierArtikels();
		$content['zones']=$mdl->getZonesAankoper($_SESSION['VMI']['contactid']);
		$content['artikels']=$mdl->getArtikelsZoneLeverancier();
		$this->template->nav = View::factory('nav/leverancier',$nav);
		$this->template->content = View::factory('leverancier/zoneartikels',$content);
	}

	public function action_leeggoed()
	{
		$mdl= new Model_Login();
		$nav['slLev']=$mdl->getLeveranciers(1);
		$mdl= new Model_Leeggoed();
		$content['leeggoed']=$mdl->getLeeggoed();
		$this->template->nav = View::factory('nav/leverancier',$nav);
		$this->template->content = View::factory('leverancier/leeggoed',$content);
	}

	public function action_fiche()
	{
		$mdl= new Model_Login();
		$nav['slLev']=$mdl->getLeveranciers();
		$content['landen']=$mdl->getLanden();
		$mdl= new Model_Leverancier();
		$content['fiche']=$mdl->getFicheLeverancier();
		$content['contacten']=$mdl->getContactenLeverancier();
		$content['mailapp'] = Kohana::$config->load('appconf.mailapp');
		$this->template->nav = View::factory('nav/leverancier',$nav);
		$this->template->content = View::factory('leverancier/fiche',$content);
	}

	/* PDF */
	public function action_pdfBestelHistoriek()
	{
		try{
			$this->profiler = NULL;
			$this->auto_render = FALSE;
			$this->response->headers('Content-Type','application/pdf');

			$mdl= new Model_Leverancier();
			$leverancier=$mdl->getFicheLeverancier();

			$mdl= new Model_LeverancierArtikels();
			$artikels=$mdl->getBestelLijstLeverancier();

			include('assets/pdf/historiek_pdf.php');
			// FPDF object
			$bpdf = new HistoriekPDF('L');
			$bpdf->SetAutoPageBreak(true, 10);
			$bpdf->SetDrawColor(180);
			$bpdf->SetTextColor(50);
			$bpdf->setGegevens($leverancier);
			$bpdf->AliasNbPages();
			$bpdf->SetDisplayMode(100);
			$bpdf->SetFont('Helvetica','',10);
			$bpdf->AddPage();
			$bpdf->HistoriekTabel($artikels);
			$bpdf->Output('historiek.pdf','I');
		}catch(Exception $error){
			Log::instance()->add(Log::ERROR, $error->getMessage());
			$this->redirect('leverancier/bestel');
		}
	}
	/* SETTERS */
	public function action_setWinkelmandje()
	{
		$mdl= new Model_Winkelmandje();
	    $output = $mdl->setMandje($_POST['geg']);
		echo json_encode($output);
	}

	public function action_setBestelling()
	{
		$mdl= new Model_Orders();
		$output = $mdl->setOrder($_POST);
		/*if($_SESSION['VMI']['gebruiker']=="aankoper"){
			$output = $mdl->setOrderLeverancier($_POST);
		} else {
			$output = $mdl->setOrderDesadvLeverancier($_POST);
		}*/

		echo json_encode($output);
	}

	public function action_setBevestiging()
	{
		$mdl= new Model_Leveringen();
	    $output = $mdl->setLeveringLeverancier($_POST);
		echo json_encode($output);
	}

	public function action_setPrijs()
	{
		$mdl= new Model_Orders();
	    $output = $mdl->setOrderPrijs($_POST);
		echo json_encode($output);
	}

	/* ADD ZONE LEVERANCIER */
	public function action_setLeverancierZone()
	{
		$mdl= new Model_LeverancierArtikels();
		$response = $mdl->setLeverancierZone($_POST['zonenaam']);
		echo json_encode($response);
	}
	public function action_setLeverancierZoneArtikel()
	{
		$mdl= new Model_LeverancierArtikels();
		$response = $mdl->setLeverancierZoneArtikel($_POST);
		echo json_encode($response);
	}


	/* SET GEGEVENS LEEGGOED */
	public function action_setLeeggoed()
	{
		$mdl= new Model_Leeggoed();
		$response = $mdl->setLeeggoedLeverancier($_POST);
		echo json_encode($response);
	}

	public function action_setLeeggoedPrijs()
	{
		$mdl= new Model_Leeggoed();
		$response = $mdl->setLeeggoedLeverancierPrijs($_POST);
		echo json_encode($response);
	}

	/* ARTIKELS */
	public function action_setArtikels()
	{
		$mdl= new Model_LeverancierArtikels();
		$response = $mdl->setArtikels($_POST['artikels']);
		echo json_encode($response);
	}


	/* LEVERANCIER FICHE */

	public function action_setFiche()
	{
		$mdl= new Model_Leverancier();
		$response = $mdl->setLeverancier($_POST);
		echo json_encode($response);
	}
	public function action_delLeverancierContact()
	{
		$mdl= new Model_Leverancier();
		$response = $mdl->delLeverancierContact($_POST['leveranciercontactid']);
		echo json_encode($response);
	}
	public function action_setGroep()
	{
		$mdl= new Model_Leverancier();
		$response = $mdl->setGroep($_SESSION['selectedgroep'],$_POST['levid'],$_POST['actie']);
		echo json_encode($response);
	}


}
?>
