<?php defined('SYSPATH') or die('No direct script access.');

class Model_Leverancier extends Kohana_Model
{
	public function autoLeverancier()
	{
		try{
			$sql = "SELECT leverancierid as id, naam as naam
					FROM leverancier
					WHERE (naam REGEXP :term OR leverancierid REGEXP :term)
					ORDER BY naam; ";
			$query = DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':term'=>$_GET['term']));
			$db = $query->execute()->as_array();
			return $db;
		}catch(Exception $error){
			Log::instance()->add(Log::ERROR, $error->getMessage());
			return array();
		}
	}

	public function getFicheLeverancier($levid=NULL)
	{
		try{
			if(empty($levid)){
				$levid=$_SESSION['VMI']['slLev'];
			}
			$sql="SELECT l.leverancierid, l.naam, l.info, l.actief,
				l.login, l.paswoordcrypted as paswoord, l.bevestigd,
				l.straatnr, l.plaats, l.postcode, l.land, l.edi
				FROM leverancier l
				WHERE l.leverancierid=:levid ";
			$query =  DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':levid'=>$levid));
			$db= $query->execute()->as_array();
			if(isset($db[0])){
				$sf = new Secretfunc(Kohana::$config->load('appconf.key'));
				$db[0]['paswoord'] =$sf->decrypt($db[0]['paswoord']);
				return $db[0];
			}else {
				return array();
			}
		}catch(Exception $error){
			Log::instance()->add(Log::ERROR, $error->getMessage());
			return array();
		}

	}

	public function getContactenLeverancier()
	{
		try{
			$sql="SELECT leveranciercontactid, leverancierid, naam, voornaam, email, tel, gsm, functie, CAST(apps AS UNSIGNED) as apps
				FROM leveranciercontact
				WHERE leverancierid=:levid; ";
			$query =  DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':levid'=>$_SESSION['VMI']['slLev']));
			$db= $query->execute()->as_array();
			return $db;
		} catch(Exception $e) {
			Log::instance()->add(Log::ERROR, $e->getMessage());
			return array();
		}
	}

	public function getContactenLeverancierMail($levid,$apps)
	{
		try{
			$sql="SELECT GROUP_CONCAT(email) as mail
				FROM leveranciercontact
				WHERE leverancierid=:levid AND apps&".$apps."; ";
			$query =  DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':levid'=>$levid));
			$db= $query->execute()->as_array();
			if(isset($db[0])){
				return $db[0];
			}else {
				return array();
			}
		} catch(Exception $e) {
			Log::instance()->add(Log::ERROR, $e->getMessage());
			return array();
		}
	}

	public function setLeverancier($post)
	{
		try{
			Database::instance()->begin();
			if($post['levid']==0){
				//eerst check id
				$check=true;
				$i=22;
				do {
					$sql="SELECT leverancierid FROM leverancier WHERE leverancierid=:levid ";
					$query =  DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':levid'=>$i));
					$db=$query->execute()->as_array();
					if(empty($db)){
						$levid=$i;
						$check=false;
					}else{
						$i++;
					}
				} while ($check);

				//insert lev
				$sql="INSERT INTO leverancier (leverancierid, naam) VALUES (:leverancierid,:val) ; " ;
				$query=DB::query(Database::INSERT, $sql, FALSE)->parameters(array(":leverancierid"=>$levid,":val"=>$post['levfiche']['naam']['val']));
				$db=$query->execute();
				if(isset($post['levfiche']['login'])){
					$post['levfiche']['login']['val']="L".str_pad($levid, 4, "0", STR_PAD_LEFT);
				}
			} else {
				$levid=$post['levid'];
			}


			foreach($post['levfiche'] as $k=>$geg){
				if(strlen($geg['oudval'])==0 ){ $geg['oudval']=NULL; }
				if(strlen($geg['val'])==0){ $geg['val']=NULL; }
				if($geg['oudval']!=$geg['val']){
					$kolom=LogVMI::getVarKolom($geg['kolomid']);
					if($geg['multiple']=='true'){
						//CONTROLE INSERT
						$check=array_diff(explode(",",$geg['val']),explode(",",$geg['oudval']));
						foreach($check as $c){
							if(!empty($c)){
								$sql="INSERT INTO ".$kolom['tabel']." (leverancierid, ".$kolom['kolom'].") VALUES (:leverancierid,:val) ; " ;
								$query=DB::query(Database::INSERT, $sql, FALSE)->parameters(array(":leverancierid"=>$levid,":val"=>$c));
								$db=$query->execute();
							}
						}
						//CONTROLE DELETE
						$check=array_diff(explode(",",$geg['oudval']),explode(",",$geg['val']));
						foreach($check as $c){
							if($c!=0){
								$sql="DELETE FROM ".$kolom['tabel']." WHERE leverancierid=:leverancierid AND ".$kolom['kolom']."=:val ; " ;
								$query=DB::query(Database::DELETE, $sql, FALSE)->parameters(array(":leverancierid"=>$levid,":val"=>$c));
								$db=$query->execute();
							}
						}
					}else{
						//UPDATE
						//CHECK PASWOORD
						if($kolom['kolom']=="paswoordcrypted"){
							$sf = new Secretfunc(Kohana::$config->load('appconf.key'));
							$geg['val']=$sf->encrypt($geg['val']);
						}
						$sql="UPDATE  ".$kolom['tabel']." SET  ".$kolom['kolom']."=:val WHERE leverancierid=:leverancierid ; " ;
						$query=DB::query(Database::UPDATE, $sql, FALSE)->parameters(array(":leverancierid"=>$levid,":val"=>$geg['val']));
						$db=$query->execute();
						if($db>0 && $kolom['tabel']=="leverancier" ){
							//CHANGE
							$sql="UPDATE leverancier SET  bchanged=255 WHERE leverancierid=:leverancierid ; " ;
							$query=DB::query(Database::UPDATE, $sql, FALSE)->parameters(array(":leverancierid"=>$levid,":val"=>$geg['val']));
							$query->execute();
						}
					}
				}
			}

			if(isset($post['levcontacten'])){
				foreach($post['levcontacten'] as $contact){
					//eerst check insert
					$contactid=$contact['leveranciercontactid']['val'];
					if($contactid==0){
						//INSERT
						$sql="INSERT INTO leveranciercontact (leverancierid) VALUES (:leverancierid) ; " ;
						$query=DB::query(Database::INSERT, $sql, FALSE)->parameters(array(":leverancierid"=>$levid));
						$db=$query->execute();
						$contactid=$db[0];
					}

					foreach($contact as $k=>$geg){
						if(strlen($geg['oudval'])==0 ){ $geg['oudval']=NULL; }
						if(strlen($geg['val'])==0){ $geg['val']=NULL; }
						if($geg['oudval']!=$geg['val']){
							$kolom=LogVMI::getVarKolom($geg['kolomid']);
							//UPDATE
							$sql="UPDATE leveranciercontact SET  ".$kolom['kolom']."=:val WHERE leverancierid=:leverancierid AND leveranciercontactid=:contactid ; " ;
							$query=DB::query(Database::UPDATE, $sql, FALSE)->parameters(array(":contactid"=>$contactid,":leverancierid"=>$levid,":val"=>$geg['val']));
							$db=$query->execute();
						}
					}
				}
			}

			Database::instance()->commit();

			$response['success']=true;
			$response['titel']="Info";
			$response['message']="Gegevens zijn opgeslagen.";
		}catch(Exception $error){
			Database::instance()->rollback();
			$response['success']=false;
			$response['titel']="Error";
			$response['message']="Er is een fout opgetreden.<br/>Error:".$error->getMessage()."<br/><br/>";
			Log::instance()->add(Log::ERROR, $error->getMessage());
		}
		return $response;
	}

	public function delLeverancierContact($levcontactid)
	{
		try{
			//delete
			$sql="DELETE FROM leveranciercontact WHERE leveranciercontactid=:levcontactid ;";
			$query=DB::query(Database::DELETE, $sql, FALSE)->parameters(array(':levcontactid'=>$levcontactid));
			$query->execute();

			$response['success']=true;
			$response['titel']="Info";
			$response['message']="Gegevens zijn opgeslagen.";
		}catch(Exception $error){
			$response['success']=false;
			$response['titel']="Error";
			$response['message']="Er is een fout opgetreden.<br/>Error:".$error->getMessage()."<br/><br/>";
			Log::instance()->add(Log::ERROR, $error->getMessage());
		}
		return $response;
	}
}
?>
